
/* cift5-c.c -- CIF test 5, C part */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>

#include "cifccsp.h"

void out_string (char *str, Channel *out)
{
	unsigned char *ch = (unsigned char *)str;

	while (*ch != '\0') {
		/* ChanOut (out, ch, 1); */
		ChanOutChar (out, *ch);
		ch++;
	}
	return;
}

void my_process (Process *me, Channel *kroc_err)
{
	char str[64];
	int v;

	v = 0;
	memcpy (str, "XXXfoobarcoXXX\n\0", 16);
	out_string (str, kroc_err);
	EXTERNAL_CALLN (fprintf, stderr, "hello EXTERNAL_CALLN world! %d\n", v);
	EXTERNAL_CALLN (sprintf, str, "hello world! %d\n", v);
	out_string (str, kroc_err);
	return;
}


/* allocates process and returns address to occam world */
void real_cift5_init (int *raddr, Channel *c)
{
	Process *p = ProcAlloc (my_process, 4096, 1, c);

	*raddr = (int)p;
	return;
}

/* frees memory used by a process -- lets hope it's finished :) */
void real_cift5_free (int addr)
{
	Process *p = (Process *)addr;

	ProcAllocClean (p);
	return;
}

void _cift5_init (int *ws) { real_cift5_init ((int *)(ws[0]), (Channel *)(ws[1])); }
void _cift5_free (int *ws) { real_cift5_free ((int)(ws[0])); }

