/*
 *	Portable timer implementation
 *	Copyright (C) 1996-1999 Jim Moores
 *	Modifications (C) 2000 Fred Barnes <frmb2@ukc.ac.uk>
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation; either version 2 of the License, or
 *	(at your option) any later version.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/*
 * only include these definitions if not using the faster 
 * macro definitions in the header file.
 * There are some extra functions defined at the end of this
 * block - these are the functions used by the kernel, but 
 * are derived from the CERN/UKC spec so that only those need
 * be provided.
 */

/*
 *	Note: Only the UNIX timer implementation exists here now
 */

#define __TIMER_C

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#ifdef OOS_BUILD
#include <oos_funcs.h>
#endif

#ifdef ENABLE_CPU_TIMERS
	extern unsigned long glob_cpufactor;		/* 2^32 / (CPU Mhz) */
	extern unsigned long glob_cpukhz;		/* (CPU Mhz) * 1024 */
#endif

#include <arch/timer.h>


