/*
 *	dmem.h -- dynamic memory allocator (i386 specific stuffs)
 *	Copyright (C) 2000-2005 Fred Barnes <frmb@kent.ac.uk>
 *	Based on Per Brinch Hansen's parallel allocator as adapted by David Wood
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation; either version 2 of the License, or
 *	(at your option) any later version.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __DMEM_H
#define __DMEM_H

static inline int bsr (int v)
{
	int res;

	__asm__ __volatile__ ("		\n" \
		"	bsr	%1,%0	\n" \
		: "=r" (res) : "r" (v) : "cc");
	return res;
}


#endif	/* !__DMEM_H */

